Subject: bug#53230: closed (Re: bug#53230: Disable authentication seems broken)

From: [email-masked] (GNU bug Tracking System)
Date: Thu, 13 Jan 2022 22:16:02 +0000

Your bug report

#53230: time-machine crashes with type error when passed --disable-authentication

which was filed against the guix package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
53230: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=53230
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#53230: Disable authentication seems broken
From: Ludovic Courtès <[email-masked]>
To: Andrew Tropin <[email-masked]>
Cc: [email-masked]
Date: Thu, 13 Jan 2022 23:15:47 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

Andrew Tropin <[email-masked]> skribis:

> A day ago I found out that I can't pull/time-machine from my local guix
> repo with patches.  After running guix time-machine -C ./channels ...,
> guix reported the following:
>
> Updating channel 'guix' from Git repository at 'https://git.savannah.gnu.org/git/guix.git'...
> guix time-machine: warning: channel authentication disabled
> Computing Guix derivation for 'x86_64-linux'... -
> Backtrace:
>           18 (primitive-load "/home/bob/.config/guix/current/bin/guix")
> In guix/ui.scm:
>    2206:7 17 (run-guix . _)
>   2169:10 16 (run-guix-command _ . _)
> In ice-9/boot-9.scm:
>   1752:10 15 (with-exception-handler _ _ #:unwind? _ #:unwind-for-type _)
>   1747:15 14 (with-exception-handler #<procedure 7f66dc8711b0 at ice-9/boot-9.…> …)
> In guix/store.scm:
>     671:3 13 (_)
> In ice-9/boot-9.scm:
>   1752:10 12 (with-exception-handler _ _ #:unwind? _ #:unwind-for-type _)
> In guix/store.scm:
>    658:37 11 (thunk)
> In guix/status.scm:
>     802:4 10 (call-with-status-report _ _)
> In guix/store.scm:
>    1320:8  9 (call-with-build-handler _ _)
>    1320:8  8 (call-with-build-handler #<procedure 7f66dc887840 at guix/ui.scm:…> …)
>   2123:24  7 (run-with-store #<store-connection 256.99 7f66dc829460> _ # _ # _ # …)
> In guix/inferior.scm:
>    817:16  6 (_ _)
> In guix/store.scm:
>   1995:38  5 (_ #<store-connection 256.99 7f66ca72bdc0>)
>    1468:0  4 (add-temp-root #<store-connection 256.99 7f66ca72bdc0> #<derivatio…>)
> In guix/serialization.scm:
>    130:20  3 (write-store-path #<derivation /gnu/store/pqn1xr6882907b41j6mybvs…> …)
> In unknown file:
>            2 (string->utf8 #<derivation /gnu/store/pqn1xr6882907b41j6mybvsg4218…>)
> In ice-9/boot-9.scm:
>   1685:16  1 (raise-exception _ #:continuable? _)
>   1685:16  0 (raise-exception _ #:continuable? _)
>
> ice-9/boot-9.scm:1685:16: In procedure raise-exception:
> In procedure string->utf8: Wrong type argument in position 1 (expecting
> string): #<derivation /gnu/store/pqn1xr6882907b41j6mybvsg4218kc0k-profile.drv =>
> /gnu/store/3hc33q0xlajd75l52grsg8dg1ais2hss-profile 7f66cb7eaeb0>

Fixed in b1fc98d6b063a117fe2bcc19a60c8b9a48301593, thanks!

Ludo’.

Subject: Disable authentication seems broken
From: Andrew Tropin <[email-masked]>
To: [email-masked]
Date: Thu, 13 Jan 2022 16:58:59 +0300
List-Id: <debbugs-submit.debbugs.gnu.org>

A day ago I found out that I can't pull/time-machine from my local guix
repo with patches.  After running guix time-machine -C ./channels ...,
guix reported the following:

--8<---------------cut here---------------start------------->8---
Updating channel 'guix' from Git repository at 'https://git.savannah.gnu.org/git/guix.git'...
guix time-machine: warning: channel authentication disabled
Computing Guix derivation for 'x86_64-linux'... -
Backtrace:
          18 (primitive-load "/home/bob/.config/guix/current/bin/guix")
In guix/ui.scm:
   2206:7 17 (run-guix . _)
  2169:10 16 (run-guix-command _ . _)
In ice-9/boot-9.scm:
  1752:10 15 (with-exception-handler _ _ #:unwind? _ #:unwind-for-type _)
  1747:15 14 (with-exception-handler #<procedure 7f66dc8711b0 at ice-9/boot-9.…> …)
In guix/store.scm:
    671:3 13 (_)
In ice-9/boot-9.scm:
  1752:10 12 (with-exception-handler _ _ #:unwind? _ #:unwind-for-type _)
In guix/store.scm:
   658:37 11 (thunk)
In guix/status.scm:
    802:4 10 (call-with-status-report _ _)
In guix/store.scm:
   1320:8  9 (call-with-build-handler _ _)
   1320:8  8 (call-with-build-handler #<procedure 7f66dc887840 at guix/ui.scm:…> …)
  2123:24  7 (run-with-store #<store-connection 256.99 7f66dc829460> _ # _ # _ # …)
In guix/inferior.scm:
   817:16  6 (_ _)
In guix/store.scm:
  1995:38  5 (_ #<store-connection 256.99 7f66ca72bdc0>)
   1468:0  4 (add-temp-root #<store-connection 256.99 7f66ca72bdc0> #<derivatio…>)
In guix/serialization.scm:
   130:20  3 (write-store-path #<derivation /gnu/store/pqn1xr6882907b41j6mybvs…> …)
In unknown file:
           2 (string->utf8 #<derivation /gnu/store/pqn1xr6882907b41j6mybvsg4218…>)
In ice-9/boot-9.scm:
  1685:16  1 (raise-exception _ #:continuable? _)
  1685:16  0 (raise-exception _ #:continuable? _)

ice-9/boot-9.scm:1685:16: In procedure raise-exception:
In procedure string->utf8: Wrong type argument in position 1 (expecting
string): #<derivation /gnu/store/pqn1xr6882907b41j6mybvsg4218kc0k-profile.drv =>
/gnu/store/3hc33q0xlajd75l52grsg8dg1ais2hss-profile 7f66cb7eaeb0>
--8<---------------cut here---------------end--------------->8---

Later I discovered, that the problem isn't related to my local changes,
it reproduces with main guix channel too, also, other people on their
setups reporting the same problem.

Way to reproduce:
1. Find any commit you didn't built guix for earlier.  For example a79ad5fce5.

2.1 Update guix to the latest version and do describe under time-machine: 
guix pull && guix time-machine --commit=a79ad5fce5 --disable-authentication -- describe

2.2 or more preciese and less invasive alternative:
guix time-machine --commit=0f869287ebf -- time-machine --commit=a79ad5fce5 --disable-authentication -- describe

To be sure, I tried it on a separate machine with only guix channel,
which wasn't updated for a while. 2.2 failed the same way as described
at the beginning, but when I tried just:

guix time-machine --commit=a79ad5fce5 --disable-authentication -- describe

it worked.  Also, I did similiar test like in 2.1 with guix pull and
after that guix pull --roll-back, the result is the same.

Skimming throught the latest changes didn't bring any results yet.
Bisecting and building guix, will let you know, if/when I find more.

-- 
Best regards,
Andrew Tropin